@echo off
setlocal enableextensions enabledelayedexpansion

REM Syntax: <thisscript> method owner token "directory" "file" "file" "file" ...
REM         method should be {disable, enable}
REM         owner should be {TI, ADMIN, ADSY} and sets owner on "enable"
REM         token should be without spaces
REM         file can contain wildcards
REM
REM set environment variable "diags" to "1" to see extended logging
REM set environment variable "diagX" to "1" to see "dir /q" (owners) of the folder

REM set diags=1
REM set diagX=1


set METHOD=%1
shift
set OWNER=%1
shift
set TOKEN=%1
shift
set CURRENTDIR=%1
shift

if /I !METHOD! EQU disable goto :methodcontinue
if /I !METHOD! EQU enable  goto :methodcontinue
echo.######## ERROR ######## sfp - Invalid method specified.
exit /b 2
goto :EOF
:methodcontinue

if /I !OWNER! EQU TI goto :ownercontinue
if /I !OWNER! EQU ADMIN  goto :ownercontinue
if /I !OWNER! EQU ADSY  goto :ownercontinue
echo.######## ERROR ######## sfp - Invalid owner specified.
exit /b 2
goto :EOF
:ownercontinue


if !diags! == 1 echo.*** Processing directory '!CURRENTDIR!'
if !diagX! == 1 call dir /q !CURRENTDIR!


if /I !METHOD! EQU disable call :Do!METHOD! DIR !CURRENTDIR! . dir

:ProcessFiles
if !errorlevel! EQU 0 (
    if "%1" EQU "" goto :ProcessingFinished
    SET CURRENTFILE=!CURRENTDIR!\%1
    if !diags! == 1 echo.*** Processing file '!CURRENTFILE!'
    if not exist !CURRENTFILE! (echo.________ sfp - file !CURRENTFILE! not found ^(ignored^)) else (
        call :Do!METHOD! FILE !CURRENTDIR! %1 %1
        if !errorlevel! NEQ 0 goto :ProcessingFailed
    )
    shift
)
if !errorlevel! EQU 0 goto :ProcessFiles
goto :ProcessingFailed


:ProcessingFinished
if /I !METHOD! NEQ disable call :Do!METHOD! DIR !CURRENTDIR! . dir
if !errorlevel! NEQ 0 goto :ProcessingFailed_FolderHandled
if !diags! == 1 echo.*** Processing for !CURRENTDIR! suceeded.
if !diagX! == 1 call dir /q !CURRENTDIR!
goto :EOF


:ProcessingFailed
if /I !METHOD! NEQ disable call :Do!METHOD! DIR !CURRENTDIR! . dir
:ProcessingFailed_FolderHandled
echo.######## PROCESSING FAILED ######## sfp failed for !CURRENTDIR!
call dir /q !CURRENTDIR!
exit /b 3
goto :EOF



:DoDisable
SET TARGETTYPE=%1
shift
if /I !TARGETTYPE! EQU DIR  goto :typeok
if /I !TARGETTYPE! EQU FILE goto :typeok
echo.######## ERROR ######## sfp:disable - Invalid target type !TARGETTYPE! specified.
exit /b 2
goto :EOF
:typeok

SET TARGET=%1\%2
SET TARGET="!TARGET:"=!"
SET SAVEFILE="%IESETUP%\!TOKEN!_%3.txt"
SET SAVEFILE="!SAVEFILE:"=!"
for /f "usebackq tokens=1,2,3,4,4,5,6,7,8,9 delims=*?" %%a in ('!SAVEFILE!') do @SET SAVEFILE=%%a%%b%%c%%d%%e%%f%%g%%h%%i
if !diags! == 1 echo.*** Processing target !TARGET! into savefile !SAVEFILE!

REM Diagnostic
if !diagX! == 1 icacls !TARGET! /q

REM Take ownership
call :DoRun takeown /A /f !TARGET!
if !errorlevel! NEQ 0 (
    echo.######## FAILED ######## sfp - takeown, file:'%*'
    goto :EOF
)

REM Save ACLS
call :DoRun icacls !TARGET! /save !SAVEFILE! /q
if !errorlevel! NEQ 0 (
    echo.######## FAILED ######## sfp - save, file:'%*'
    goto :EOF
)

REM Grant control
if !TARGETTYPE! EQU DIR  call :DoRun icacls !TARGET! /grant "BUILTIN\Administrators:(OI)(CI)(F)" "BUILTIN\Administrators:(F)" /q
if !TARGETTYPE! EQU FILE call :DoRun icacls !TARGET! /grant "BUILTIN\Administrators:(F)" /q
if !errorlevel! NEQ 0 (
    echo.######## FAILED ######## sfp - grant, file:'%*'
    goto :EOF
)

REM Diagnostic
if !diags! == 1 icacls !TARGET! /q
goto :EOF



:DoEnable
SET RESULT=0
SET TARGETTYPE=%1
if /I !TARGETTYPE! EQU DIR  goto :typeok2
if /I !TARGETTYPE! EQU FILE goto :typeok2
echo.######## ERROR ######## sfp:enable - Invalid target type !TARGETTYPE! specified.
exit /b 2
goto :EOF
:typeok2

shift
SET TARGET=%1\%2
SET TARGET="!TARGET:"=!"
SET TARGETDIR=%1
SET TARGETDIR="!TARGETDIR:"=!"
SET SAVEFILE="%IESETUP%\!TOKEN!_%3.txt"
SET SAVEFILE="!SAVEFILE:"=!"
for /f "usebackq tokens=1,2,3,4,4,5,6,7,8,9 delims=*?" %%a in ('!SAVEFILE!') do @SET SAVEFILE=%%a%%b%%c%%d%%e%%f%%g%%h%%i
if !diags! == 1 echo.*** Processing target !TARGET! from savefile !SAVEFILE!

REM Diagnostic
if !diagX! == 1 icacls !TARGET! /q

REM Set ownership
if !OWNER! EQU TI    call :DoRun icacls !TARGET! /setowner "NT SERVICE\TrustedInstaller" /q
if !OWNER! EQU ADMIN call :DoRun icacls !TARGET! /setowner "BUILTIN\Administrators" /q
if !OWNER! EQU ADSY  if !TARGETTYPE! EQU DIR  call :DoRun icacls !TARGET! /setowner "BUILTIN\Administrators" /q
if !OWNER! EQU ADSY  if !TARGETTYPE! EQU FILE call :DoRun icacls !TARGET! /setowner "NT AUTHORITY\SYSTEM" /q
if !errorlevel! NEQ 0 (
    echo.######## FAILED ######## sfp - setowner, file:'%*'
    SET RESULT=3
)

REM Restore ACLS
if exist !SAVEFILE! call :DoRun icacls !TARGETDIR! /restore !SAVEFILE! /q
if !errorlevel! NEQ 0 (
    echo.######## FAILED ######## sfp - restore, file:'%*'
    SET RESULT=3
)

REM Diagnostics
if !diags! == 1 icacls !TARGET! /q
exit /b !RESULT!
goto :EOF



:DoRun
if !diags! == 1 echo.*** %*
%*
goto :EOF
